# python3
import serpent

def rol32(n: int, i: int) -> bytes:
    return ((n << i) & 0xFFFFFFFF) | (n >> (32 - i))

def decrypt_base(data: bytes, key: int):
    assert 0 <= key <= 0xFFFFFFFF # 4 bytes key !
    assert len(data) % 4 == 0 # size must be aligned
    n = len(data) >> 2
    data = [int.from_bytes(data[4*i:4*i+4], 'little') for i in range(n)]
    data2 = [i for i in data]
    for i in range(n):
        if i == 0:
            data2[i] = (key ^ data[i])
        else:
            data2[i] = (key ^ data[i]) ^ data[i - 1]
        data2[i] = rol32(data2[i], 4*(i % 2))
    r = []
    for i in range(n):
        for j in [0, 1, 2, 3]:
            r.append((data2[i] >> (8*j)) & 0xFF)
    return bytearray(r)

if __name__ == '__main__':
    with open('DiMap', 'rb') as f:
        data = f.read()
    data = decrypt_base(data, 0xFB307BFA)
    serpent_key = b'GSPyrv3C79ZbR0k1'
    data = serpent.serpent_cbc_decrypt(serpent_key, data)
    with open('out.zip', 'wb') as f:
        f.write(data)
    print ('[+] Done!')